MIR_APP_DLL(bool) PU::IsProcessElevated()
{
	HANDLE hToken = 0;
	// Open the primary access token of the process with TOKEN_QUERY.
	if(OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, &hToken));
	{
		TOKEN_ELEVATION elevation;
		DWORD dwSize;
		// Retrieve token elevation information.
		/* 
		  When the process is run on operating systems prior to Windows
		  Vista, GetTokenInformation returns FALSE with the
		  ERROR_INVALID_PARAMETER error code because TokenElevation is
		  not supported on those operating systems.
		*/
		if(GetTokenInformation(hToken, TokenElevation, &elevation, sizeof(elevation), &dwSize))
			return elevation.TokenIsElevated != 0;
		else
			SetLastError(6);
	}

	// Centralized cleanup for all allocated resources.
	if (hToken > 0)
		CloseHandle(hToken);
	else if (hToken < 0)
		SetLastError(6);
	else
		hToken = 0;
	// throw dwError
	return false;
}